from graph import *
from heft import *
from job import *
from utils import *
import networkx as nx
from networkx.algorithms.dag import dag_longest_path
import json

def makespan(schedule):
    """
    Args:
    - schedule: List of tuples (task ID, processor ID, start time, finish time), schedule generated by the HEFT algorithm.

    Returns:
    - Finish time of the last job in the schedule.
    """
    finish_time = max(task[3] for task in schedule)
    return finish_time

def flow(schedule):
    """
    Args:
    - schedule: List of tuples (task ID, processor ID, start time, finish time), schedule generated by the HEFT algorithm.

    Returns:
    - flow_metric: number of completed tasks divided by makespan.
    """
    makespan_value = makespan(schedule)
    completed_tasks = sum(1 for task in schedule if task[3] == makespan_value)
    flow_metric = completed_tasks / makespan_value
    return flow_metric


def critical_path_length(json_path):
    """
   Args:
    - json file
    Returns:
    - critical_path_length: Length of the critical path.
    """
    job = Job(json_path)

    nx_graph = job.dependence_graph

    critical_path = dag_longest_path(nx_graph)
    critical_path_duration = sum(job.durations[node] for node in critical_path)

    return critical_path_duration


def SLR(schedule, job):
    """
    Args:
    - schedule: List of tuples (task ID, processor ID, start time, finish time), schedule generated by the HEFT algorithm.
    - job: An instance of the Job class containing task durations.

    Returns:
    - SLR: Schedule Length Ratio = makespan / time of the critical path.
    """
    makespan_value = makespan(schedule)
    critical_path_time = critical_path_length(job.dependence_graph, job.durations)
    SLR_value = makespan_value / critical_path_time
    return SLR_value


def utilization_rate(schedule):
    """
    Computes the utilization rate of each machine in a schedule.

    Args:
    - schedule: List of tuples (task ID, processor ID, start time, finish time), schedule generated by the HEFT algorithm.

    Returns:
    - utilization_rates: A dictionary containing the utilization rate of each processor.
    """
    total_time = {} 
    busy_time = {} 

    # Total available time for each processor
    for task in schedule:
        proc_id = task[1]  
        finish_time = task[3] 
        total_time[proc_id] = max(total_time.get(proc_id, 0), finish_time)

    # Total busy time for each machine
    for task in schedule:
        proc_id = task[1] 
        start_time = task[2]  
        finish_time = task[3]  
        busy_time[proc_id] = busy_time.get(proc_id, 0) + (finish_time - start_time)

    # Utilization rate for each processor
    utilization_rates = {}
    for proc_id, total_time in total_time.items():
        busy_time = busy_time.get(proc_id, 0)
        utilization_rates[proc_id] = busy_time / total_time

    return utilization_rates


def speedup(schedule_sequential, schedule_parallel):
    return makespan(schedule_parallel)/makespan(schedule_sequential)
